The zxdg_surface_v6 interface

## Data Structures

struct | zxdg_surface_v6_listener

## Macros

#define | ZXDG_SURFACE_V6_CONFIGURE_SINCE_VERSION 1
#define | ZXDG_SURFACE_V6_DESTROY_SINCE_VERSION 1
#define | ZXDG_SURFACE_V6_GET_TOPLEVEL_SINCE_VERSION 1
#define | ZXDG_SURFACE_V6_GET_POPUP_SINCE_VERSION 1
#define | ZXDG_SURFACE_V6_SET_WINDOW_GEOMETRY_SINCE_VERSION 1
#define | ZXDG_SURFACE_V6_ACK_CONFIGURE_SINCE_VERSION 1

## Functions

static int | zxdg_surface_v6_add_listener (struct zxdg_surface_v6 *zxdg_surface_v6, const struct zxdg_surface_v6_listener *listener, void *data)
static void | zxdg_surface_v6_set_user_data (struct zxdg_surface_v6 *zxdg_surface_v6, void *user_data)
static void * | zxdg_surface_v6_get_user_data (struct zxdg_surface_v6 *zxdg_surface_v6)
static void | zxdg_surface_v6_destroy (struct zxdg_surface_v6 *zxdg_surface_v6)
static struct zxdg_toplevel_v6 * | zxdg_surface_v6_get_toplevel (struct zxdg_surface_v6 *zxdg_surface_v6)
static struct zxdg_popup_v6 * | zxdg_surface_v6_get_popup (struct zxdg_surface_v6 *zxdg_surface_v6, struct zxdg_surface_v6 *parent, struct zxdg_positioner_v6 *positioner)
static void | zxdg_surface_v6_set_window_geometry (struct zxdg_surface_v6 *zxdg_surface_v6, int32_t x, int32_t y, int32_t width, int32_t height)
static void | zxdg_surface_v6_ack_configure (struct zxdg_surface_v6 *zxdg_surface_v6, uint32_t serial)

## Detailed Description

An interface that may be implemented by a wl_surface, for implementations that provide a desktop-style user interface.

It provides a base set of functionality required to construct user interface elements requiring management by the compositor, such as toplevel windows, menus, etc. The types of functionality are split into xdg_surface roles.

Creating an xdg_surface does not set the role for a wl_surface. In order to map an xdg_surface, the client must create a role-specific object using, e.g., get_toplevel, get_popup. The wl_surface for any given xdg_surface can have at most one role, and may not be assigned any role not based on xdg_surface.

A role must be assigned before any other requests are made to the xdg_surface object.

The client must call wl_surface.commit on the corresponding wl_surface for the xdg_surface state to take effect.

Creating an xdg_surface from a wl_surface which has a buffer attached or committed is a client error, and any attempts by a client to attach or manipulate a buffer prior to the first xdg_surface.configure call must also be treated as errors.

For a surface to be mapped by the compositor, the following conditions must be met: (1) the client has assigned a xdg_surface based role to the surface, (2) the client has set and committed the xdg_surface state and the role dependent state to the surface and (3) the client has committed a buffer to the surface.

## Macro Definition Documentation

## ZXDG_SURFACE_V6_ACK_CONFIGURE_SINCE_VERSION

#define ZXDG_SURFACE_V6_ACK_CONFIGURE_SINCE_VERSION 1

Definition at line 853 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_SURFACE_V6_CONFIGURE_SINCE_VERSION

#define ZXDG_SURFACE_V6_CONFIGURE_SINCE_VERSION 1

Definition at line 832 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_SURFACE_V6_DESTROY_SINCE_VERSION

#define ZXDG_SURFACE_V6_DESTROY_SINCE_VERSION 1

Definition at line 837 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_SURFACE_V6_GET_POPUP_SINCE_VERSION

#define ZXDG_SURFACE_V6_GET_POPUP_SINCE_VERSION 1

Definition at line 845 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_SURFACE_V6_GET_TOPLEVEL_SINCE_VERSION

#define ZXDG_SURFACE_V6_GET_TOPLEVEL_SINCE_VERSION 1

Definition at line 841 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_SURFACE_V6_SET_WINDOW_GEOMETRY_SINCE_VERSION

#define ZXDG_SURFACE_V6_SET_WINDOW_GEOMETRY_SINCE_VERSION 1

Definition at line 849 of file xdg-shell-unstable-v6-client-protocol.h.

## Function Documentation

## zxdg_surface_v6_ack_configure()

static void zxdg_surface_v6_ack_configure | ( | struct zxdg_surface_v6 * | zxdg_surface_v6,
|  | uint32_t | serial
| ) |  |

inline static

When a configure event is received, if a client commits the surface in response to the configure event, then the client must make an ack_configure request sometime before the commit request, passing along the serial of the configure event.

For instance, for toplevel surfaces the compositor might use this information to move a surface to the top left only when the client has drawn itself for the maximized or fullscreen state.

If the client receives multiple configure events before it can respond to one, it only has to ack the last configure event.

A client is not required to commit immediately after sending an ack_configure request - it may even ack_configure several times before its next surface commit.

A client may send multiple ack_configure requests before committing, but only the last request sent before a commit indicates which configure event the client really is responding to.

Definition at line 989 of file xdg-shell-unstable-v6-client-protocol.h.

References ZXDG_SURFACE_V6_ACK_CONFIGURE.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_surface_v6,
ZXDG_SURFACE_V6_ACK_CONFIGURE, serial);
}
ZXDG_SURFACE_V6_ACK_CONFIGURE
#define ZXDG_SURFACE_V6_ACK_CONFIGURE
Definition: xdg-shell-unstable-v6-client-protocol.h:827

## zxdg_surface_v6_add_listener()

static int zxdg_surface_v6_add_listener | ( | struct zxdg_surface_v6 * | zxdg_surface_v6,
|  | const struct zxdg_surface_v6_listener * | listener,
|  | void * | data
| ) |  |

inline static

Definition at line 816 of file xdg-shell-unstable-v6-client-protocol.h.

{
return wl_proxy_add_listener((struct wl_proxy *) zxdg_surface_v6,
(void (**)(void)) listener, data);
}
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1974

## zxdg_surface_v6_destroy()

static void zxdg_surface_v6_destroy | ( | struct zxdg_surface_v6 * | zxdg_surface_v6 | ) |

inline static

Destroy the xdg_surface object. An xdg_surface must only be destroyed after its role object has been destroyed.

Definition at line 882 of file xdg-shell-unstable-v6-client-protocol.h.

References ZXDG_SURFACE_V6_DESTROY.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_surface_v6,
ZXDG_SURFACE_V6_DESTROY);
wl_proxy_destroy((struct wl_proxy *) zxdg_surface_v6);
}
ZXDG_SURFACE_V6_DESTROY
#define ZXDG_SURFACE_V6_DESTROY
Definition: xdg-shell-unstable-v6-client-protocol.h:823

## zxdg_surface_v6_get_popup()

static struct zxdg_popup_v6* zxdg_surface_v6_get_popup | ( | struct zxdg_surface_v6 * | zxdg_surface_v6,
|  | struct zxdg_surface_v6 * | parent,
|  | struct zxdg_positioner_v6 * | positioner
| ) |  |

static

This creates an xdg_popup object for the given xdg_surface and gives the associated wl_surface the xdg_popup role.

See the documentation of xdg_popup for more details about what an xdg_popup is and how it is used.

Definition at line 920 of file xdg-shell-unstable-v6-client-protocol.h.

References NULL, zxdg_popup_v6_interface, and ZXDG_SURFACE_V6_GET_POPUP.

{
struct wl_proxy *id;
id = wl_proxy_marshal_constructor((struct wl_proxy *) zxdg_surface_v6,
ZXDG_SURFACE_V6_GET_POPUP, &zxdg_popup_v6_interface, NULL, parent, positioner);
return (struct zxdg_popup_v6 *) id;
}
id
GLuint id
Definition: SDL_opengl_glext.h:528
ZXDG_SURFACE_V6_GET_POPUP
#define ZXDG_SURFACE_V6_GET_POPUP
Definition: xdg-shell-unstable-v6-client-protocol.h:825
NULL
#define NULL
Definition: begin_code.h:164
zxdg_popup_v6_interface
const struct wl_interface zxdg_popup_v6_interface
Definition: xdg-shell-unstable-v6-protocol.c:157

## zxdg_surface_v6_get_toplevel()

static struct zxdg_toplevel_v6* zxdg_surface_v6_get_toplevel | ( | struct zxdg_surface_v6 * | zxdg_surface_v6 | ) |

static

This creates an xdg_toplevel object for the given xdg_surface and gives the associated wl_surface the xdg_toplevel role.

See the documentation of xdg_toplevel for more details about what an xdg_toplevel is and how it is used.

Definition at line 900 of file xdg-shell-unstable-v6-client-protocol.h.

References NULL, ZXDG_SURFACE_V6_GET_TOPLEVEL, and zxdg_toplevel_v6_interface.

{
struct wl_proxy *id;
id = wl_proxy_marshal_constructor((struct wl_proxy *) zxdg_surface_v6,
ZXDG_SURFACE_V6_GET_TOPLEVEL, &zxdg_toplevel_v6_interface, NULL);
return (struct zxdg_toplevel_v6 *) id;
}
id
GLuint id
Definition: SDL_opengl_glext.h:528
zxdg_toplevel_v6_interface
const struct wl_interface zxdg_toplevel_v6_interface
Definition: xdg-shell-unstable-v6-protocol.c:141
NULL
#define NULL
Definition: begin_code.h:164
ZXDG_SURFACE_V6_GET_TOPLEVEL
#define ZXDG_SURFACE_V6_GET_TOPLEVEL
Definition: xdg-shell-unstable-v6-client-protocol.h:824

## zxdg_surface_v6_get_user_data()

static void* zxdg_surface_v6_get_user_data | ( | struct zxdg_surface_v6 * | zxdg_surface_v6 | ) |

inline static

Definition at line 864 of file xdg-shell-unstable-v6-client-protocol.h.

{
return wl_proxy_get_user_data((struct wl_proxy *) zxdg_surface_v6);
}

## zxdg_surface_v6_set_user_data()

static void zxdg_surface_v6_set_user_data | ( | struct zxdg_surface_v6 * | zxdg_surface_v6,
|  | void * | user_data
| ) |  |

inline static

Definition at line 857 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_set_user_data((struct wl_proxy *) zxdg_surface_v6, user_data);
}

## zxdg_surface_v6_set_window_geometry()

static void zxdg_surface_v6_set_window_geometry | ( | struct zxdg_surface_v6 * | zxdg_surface_v6,
|  | int32_t | x,
|  | int32_t | y,
|  | int32_t | width,
|  | int32_t | height
| ) |  |

inline static

The window geometry of a surface is its "visible bounds" from the user's perspective. Client-side decorations often have invisible portions like drop-shadows which should be ignored for the purposes of aligning, placing and constraining windows.

The window geometry is double buffered, and will be applied at the time wl_surface.commit of the corresponding wl_surface is called.

Once the window geometry of the surface is set, it is not possible to unset it, and it will remain the same until set_window_geometry is called again, even if a new subsurface or buffer is attached.

If never set, the value is the full bounds of the surface, including any subsurfaces. This updates dynamically on every commit. This unset is meant for extremely simple clients.

The arguments are given in the surface-local coordinate space of the wl_surface associated with this xdg_surface.

The width and height must be greater than zero. Setting an invalid size will raise an error. When applied, the effective window geometry will be the set window geometry clamped to the bounding rectangle of the combined geometry of the surface of the xdg_surface and the associated subsurfaces.

Definition at line 959 of file xdg-shell-unstable-v6-client-protocol.h.

References ZXDG_SURFACE_V6_SET_WINDOW_GEOMETRY.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_surface_v6,
ZXDG_SURFACE_V6_SET_WINDOW_GEOMETRY, x, y, width, height);
}
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
width
GLint GLint GLsizei width
Definition: SDL_opengl.h:1572
ZXDG_SURFACE_V6_SET_WINDOW_GEOMETRY
#define ZXDG_SURFACE_V6_SET_WINDOW_GEOMETRY
Definition: xdg-shell-unstable-v6-client-protocol.h:826
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
height
GLint GLint GLsizei GLsizei height
Definition: SDL_opengl.h:1572